(* This file was generated automatically by wayland-scanner-ocaml *)

open struct
  module Proxy = Wayland.Proxy
  module Iface_reg = Wayland.Iface_reg
  module Metadata = Wayland.Metadata
end

module Zwp_linux_dmabuf_v1 = struct
  type t = [`Zwp_linux_dmabuf_v1]
  type _ Metadata.ty += T : [`Zwp_linux_dmabuf_v1] Metadata.ty
  type versions = [`V1 | `V2 | `V3]
  let interface = "zwp_linux_dmabuf_v1"
  let version = 3l
  
  let requests = function
    | 0 -> "destroy", []
    | 1 -> "create_params", ["params_id", `New_ID (Some "zwp_linux_buffer_params_v1")]
    | i -> Proxy.unknown_request i, []
  
  let events = function
    | 0 -> "format", ["format", `Uint]
    | 1 -> "modifier", ["format", `Uint; "modifier_hi", `Uint; "modifier_lo", `Uint]
    | i -> Proxy.unknown_event i, []
  
end
let () = Iface_reg.register (module Zwp_linux_dmabuf_v1)

module Zwp_linux_buffer_params_v1 = struct
  type t = [`Zwp_linux_buffer_params_v1]
  type _ Metadata.ty += T : [`Zwp_linux_buffer_params_v1] Metadata.ty
  type versions = [`V1 | `V2 | `V3]
  let interface = "zwp_linux_buffer_params_v1"
  let version = 3l
  
  module Error = struct
    type t =
      | Already_used : t
      | Plane_idx : t
      | Plane_set : t
      | Incomplete : t
      | Invalid_format : t
      | Invalid_dimensions : t
      | Out_of_bounds : t
      | Invalid_wl_buffer : t
    
    let to_int32 = function
      | Already_used -> 0l
      | Plane_idx -> 1l
      | Plane_set -> 2l
      | Incomplete -> 3l
      | Invalid_format -> 4l
      | Invalid_dimensions -> 5l
      | Out_of_bounds -> 6l
      | Invalid_wl_buffer -> 7l
    
    let of_int32 = function
      | 0l -> Already_used
      | 1l -> Plane_idx
      | 2l -> Plane_set
      | 3l -> Incomplete
      | 4l -> Invalid_format
      | 5l -> Invalid_dimensions
      | 6l -> Out_of_bounds
      | 7l -> Invalid_wl_buffer
      | x -> Fmt.failwith "Invalid error enum value %ld" x
  end
  
  
  module Flags = struct
    type t = int32
    
    let y_invert = 1l
    
    let interlaced = 2l
    
    let bottom_first = 4l
    
    let to_int32 = Fun.id
    let of_int32 = Fun.id
  end
  
  let requests = function
    | 0 -> "destroy", []
    | 1 -> "add", ["fd", `FD; "plane_idx", `Uint; "offset", `Uint; "stride", `Uint; "modifier_hi", `Uint;
                   "modifier_lo", `Uint]
    | 2 -> "create", ["width", `Int; "height", `Int; "format", `Uint; "flags", `Uint]
    | 3 -> "create_immed", ["buffer_id", `New_ID (Some "wl_buffer"); "width", `Int; "height", `Int; "format", `Uint;
                            "flags", `Uint]
    | i -> Proxy.unknown_request i, []
  
  let events = function
    | 0 -> "created", ["buffer", `New_ID (Some "wl_buffer")]
    | 1 -> "failed", []
    | i -> Proxy.unknown_event i, []
  
end
let () = Iface_reg.register (module Zwp_linux_buffer_params_v1)
